scala.reflect.macros.Universe

# IdentContextApi

#### trait IdentContextApi extends IdentApi

The extended API of idents that's supported in macro context universes

Self Type
  Ident
Source
  Universe.scala

Linear Supertypes
Universe.IdentApi, Universe.RefTreeApi, Universe.NameTreeApi, Universe.SymTreeApi, Universe.TreeApi, Product, Equals, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. IdentContextApi
2. IdentApi
3. RefTreeApi
4. NameTreeApi
5. SymTreeApi
6. TreeApi
7. Product
8. Equals
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def canEqual(that: Any): Boolean

   A method that should be called from every well-designed equals method that is open to be overridden in a subclass.

   A method that should be called from every well-designed equals method that is open to be overridden in a subclass. See Programming in Scala, Chapter 28 for discussion and design.

   that

     the value being probed for possible equality

   returns

     true if this instance can possibly equal `that`, otherwise false

   Definition Classes
     Equals

2. #### abstract def children: List[Tree]

   The direct child trees of this tree.

   The direct child trees of this tree. EmptyTrees are always omitted. Lists are flattened.

   Definition Classes
     TreeApi

3. #### abstract def collect[T](pf: PartialFunction[Tree, T]): List[T]

   Apply `pf' to each subtree on which the function is defined and collect the results.`

   Apply `pf' to each subtree on which the function is defined and collect the results.`

   Definition Classes
     TreeApi

4. #### abstract def duplicate: IdentContextApi.this.type

   Make a copy of this tree, keeping all attributes, except that all positions are focused (so nothing in this tree will be found when searching by position).

   Make a copy of this tree, keeping all attributes, except that all positions are focused (so nothing in this tree will be found when searching by position).

   Definition Classes
     TreeApi

5. #### abstract def equalsStructure(that: Tree): Boolean

   Tests whether two trees are structurall equal.

   Tests whether two trees are structurall equal. Note that `==` on trees is reference equality.

   Definition Classes
     TreeApi

6. #### abstract def exists(p: (Tree) ⇒ Boolean): Boolean

   Is there exists a part of this tree which satisfies predicate `p`?

   Is there exists a part of this tree which satisfies predicate `p`?

   Definition Classes
     TreeApi

7. #### abstract def filter(f: (Tree) ⇒ Boolean): List[Tree]

   Find all subtrees matching predicate `p`.

   Find all subtrees matching predicate `p`. Same as `withFilter`

   Definition Classes
     TreeApi

8. #### abstract def find(p: (Tree) ⇒ Boolean): Option[Tree]

   Returns optionally first tree (in a preorder traversal) which satisfies predicate `p`, or None if none exists.

   Returns optionally first tree (in a preorder traversal) which satisfies predicate `p`, or None if none exists.

   Definition Classes
     TreeApi

9. #### abstract def forAll(p: (Tree) ⇒ Boolean): Boolean

   Do all parts of this tree satisfy predicate `p`?

   Do all parts of this tree satisfy predicate `p`?

   Definition Classes
     TreeApi

10. #### abstract def foreach(f: (Tree) ⇒ Unit): Unit

    Apply `f` to each subtree

    Apply `f` to each subtree

    Definition Classes
      TreeApi

11. #### abstract def freeTerms: List[Universe.FreeTermSymbol]

    Extracts free term symbols from a tree that is reified or contains reified subtrees.

    Extracts free term symbols from a tree that is reified or contains reified subtrees.

    Definition Classes
      TreeApi

12. #### abstract def freeTypes: List[Universe.FreeTypeSymbol]

    Extracts free type symbols from a tree that is reified or contains reified subtrees.

    Extracts free type symbols from a tree that is reified or contains reified subtrees.

    Definition Classes
      TreeApi

13. #### abstract def isBackquoted: Boolean

    Was this ident created from a backquoted identifier?

14. #### abstract def isDef: Boolean

    Does this tree represent a definition? (of a method, of a class, etc)

    Does this tree represent a definition? (of a method, of a class, etc)

    Definition Classes
      TreeApi

15. #### abstract def isEmpty: Boolean

    Is this tree one of the empty trees? Empty trees are: the `EmptyTree` null object, `TypeTree` instances that don't carry a type and the special `emptyValDef` singleton.

    Is this tree one of the empty trees? Empty trees are: the `EmptyTree` null object, `TypeTree` instances that don't carry a type and the special `emptyValDef` singleton.

    Definition Classes
      TreeApi

16. #### abstract def isTerm: Boolean

    The canonical way to test if a Tree represents a term.

    The canonical way to test if a Tree represents a term.

    Definition Classes
      TreeApi

17. #### abstract def isType: Boolean

    The canonical way to test if a Tree represents a type.

    The canonical way to test if a Tree represents a type.

    Definition Classes
      TreeApi

18. #### abstract def name: Universe.Name

    The underlying name.

    The underlying name. For example, the `<List>` part of `Ident("List": TermName)`.

    Definition Classes
      IdentApi → RefTreeApi → NameTreeApi

19. #### abstract def orElse(alt: ⇒ Tree): Tree

    Provides an alternate if tree is empty

    Provides an alternate if tree is empty

    alt

      The alternate tree

    returns

      If this tree is non empty, this tree, otherwise `alt`.

    Definition Classes
      TreeApi

20. #### abstract def pos: Universe.Position

    Position of the tree.

    Position of the tree.

    Definition Classes
      TreeApi

21. #### abstract def productArity: Int

    The size of this product.

    The size of this product.

    returns

      for a product `A(x1, ..., xk)`, returns `k`

    Definition Classes
      Product

22. #### abstract def productElement(n: Int): Any

    The nth element of this product, 0-based.

    The nth element of this product, 0-based. In other words, for a product `A(x1, ..., xk)`, returns `x(n+1)` where `0 < n < k`.

    n

      the index of the element to return

    returns

      the element `n` elements after the first element

    Definition Classes
      Product
    Exceptions thrown
      `IndexOutOfBoundsException`

23. #### abstract def qualifier: Tree

    The qualifier of the reference.

    The qualifier of the reference. For example, the `<scala>` part of `Select("scala": TermName, "List": TermName)`. `EmptyTree` for `Ident` instances.

    Definition Classes
      RefTreeApi

24. #### abstract def substituteSymbols(from: List[Symbol], to: List[Symbol]): Tree

    Substitute symbols in `to` for corresponding occurrences of references to symbols `from` in this type.

    Substitute symbols in `to` for corresponding occurrences of references to symbols `from` in this type.

    Definition Classes
      TreeApi

25. #### abstract def substituteThis(clazz: Symbol, to: Tree): Tree

    Substitute given tree `to` for occurrences of nodes that represent `C.this`, where `C` referes to the given class `clazz`.

    Substitute given tree `to` for occurrences of nodes that represent `C.this`, where `C` referes to the given class `clazz`.

    Definition Classes
      TreeApi

26. #### abstract def substituteTypes(from: List[Symbol], to: List[Universe.Type]): Tree

    Substitute types in `to` for corresponding occurrences of references to symbols `from` in this tree.

    Substitute types in `to` for corresponding occurrences of references to symbols `from` in this tree.

    Definition Classes
      TreeApi

27. #### abstract def symbol: Symbol

    Symbol of the tree.

    Symbol of the tree.

    For most trees symbol is `null`. In `SymTree`s, it is overridden and implemented with a var, initialized to `NoSymbol`.

    Trees which are not `SymTree`s but which carry symbols do so by overriding `def symbol` to forward it elsewhere. Examples:

    - `Super(qual, _)` has `qual`'s symbol,
    - `Apply(fun, args)` has `fun`'s symbol,
    - `TypeApply(fun, args)` has `fun`'s symbol,
    - `AppliedTypeTree(tpt, args)` has `tpt`'s symbol,
    - `TypeTree(tpe)` has `tpe`'s `typeSymbol`, if `tpe != null`.
    Definition Classes
      SymTreeApi → TreeApi

28. #### abstract def tpe: Universe.Type

    Type of the tree.

    Type of the tree.

    Upon creation most trees have their `tpe` set to `null`. Types are typically assigned to trees during typechecking. Some node factory methods set `tpe` immediately after creation.

    When the typechecker encounters a tree with a non-null tpe, it will assume it to be correct and not check it again. This means one has to be careful not to erase the `tpe` field of subtrees.

    Definition Classes
      TreeApi

29. #### abstract def withFilter(f: (Tree) ⇒ Boolean): List[Tree]

    Find all subtrees matching predicate `p`.

    Find all subtrees matching predicate `p`. Same as `filter`

    Definition Classes
      TreeApi

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from IdentContextApi to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (IdentContextApi, B)

   Implicit information
     This member is added by an implicit conversion from IdentContextApi to ArrowAssoc[IdentContextApi] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

10. #### def ensuring(cond: (IdentContextApi) ⇒ Boolean, msg: ⇒ Any): IdentContextApi

    Implicit information
      This member is added by an implicit conversion from IdentContextApi to Ensuring[IdentContextApi] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (IdentContextApi) ⇒ Boolean): IdentContextApi

    Implicit information
      This member is added by an implicit conversion from IdentContextApi to Ensuring[IdentContextApi] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): IdentContextApi

    Implicit information
      This member is added by an implicit conversion from IdentContextApi to Ensuring[IdentContextApi] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): IdentContextApi

    Implicit information
      This member is added by an implicit conversion from IdentContextApi to Ensuring[IdentContextApi] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

17. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from IdentContextApi to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

21. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### def productIterator: Iterator[Any]

    An iterator over all the elements of this product.

    An iterator over all the elements of this product.

    returns

      in the default implementation, an `Iterator[Any]`

    Definition Classes
      Product

25. #### def productPrefix: String

    A string used in the `toString` methods of derived classes.

    A string used in the `toString` methods of derived classes. Implementations may override this method to prepend a string prefix to the result of `toString` methods.

    returns

      in the default implementation, the empty string

    Definition Classes
      Product

26. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

27. #### def toString(): String

    Obtains string representation of a tree

    Obtains string representation of a tree

    returns

      a String representation of the object.

    Definition Classes
      TreeApi → AnyRef → Any

28. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

29. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

30. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

31. #### def →[B](y: B): (IdentContextApi, B)

    Implicit information
      This member is added by an implicit conversion from IdentContextApi to ArrowAssoc[IdentContextApi] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implict Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from IdentContextApi to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (identContextApi: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from IdentContextApi to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (identContextApi: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: IdentContextApi

   Implicit information
     This member is added by an implicit conversion from IdentContextApi to ArrowAssoc[IdentContextApi] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (identContextApi: ArrowAssoc[IdentContextApi]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: IdentContextApi

   Implicit information
     This member is added by an implicit conversion from IdentContextApi to Ensuring[IdentContextApi] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (identContextApi: Ensuring[IdentContextApi]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from Universe.IdentApi

### Inherited from Universe.RefTreeApi

### Inherited from Universe.NameTreeApi

### Inherited from Universe.SymTreeApi

### Inherited from Universe.TreeApi

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from IdentContextApi to StringAdd

### Inherited by implicit conversion any2stringfmt from IdentContextApi to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from IdentContextApi to ArrowAssoc[IdentContextApi]

### Inherited by implicit conversion any2Ensuring from IdentContextApi to Ensuring[IdentContextApi]

### Ungrouped